/* VzImagination (C) 2018-2019 Stephane Charette <stephanecharette@gmail.com>
 * $Id: TestMatManipGreyscale.cpp 2741 2019-04-09 17:04:20Z stephane $
 */

#include "TestUtil.hpp"


TEST(Greyscale, Greyscale)
{
	for (const auto & [path, name] : test_images())
	{
		cv::Mat src = cv::imread(path, cv::IMREAD_COLOR);
		ASSERT_EQ(src.channels(), 3);

		cv::Mat dst = vz::to_greyscale(src);
		ASSERT_EQ(src.channels(), 3);
		ASSERT_EQ(dst.channels(), 1);
	}
}


TEST(Greyscale, Throws)
{
	cv::Mat src;
	ASSERT_TRUE(src.empty());

	// should not be able to convert empty images
	ASSERT_THROW(vz::to_greyscale(src), std::exception);
}


TEST(Greyscale, AlreadyGreyscale)
{
	for (const auto & [path, name] : test_images())
	{
		cv::Mat src = cv::imread(path, cv::IMREAD_GRAYSCALE);
		ASSERT_EQ(src.channels(), 1);

		cv::Mat dst = vz::to_greyscale(src);
		ASSERT_EQ(dst.channels(), 1);

		ASSERT_TRUE(vz::compare_exact(src, dst));
	}
}
